/*---------------------------------------------------------------------------------------------------------*/
/*																										   */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.										   */
/*																										   */
/*---------------------------------------------------------------------------------------------------------*/

#pragma once
#include "afxwin.h"
#include <NuWinUsb.h>


#include "BtnST.h"
#include "ShadeButtonST.h"

// GPIO_Monitor_Dlg dialog

class GPIO_Monitor_Dlg : public CDialog
{
	DECLARE_DYNAMIC(GPIO_Monitor_Dlg)

public:
	GPIO_Monitor_Dlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~GPIO_Monitor_Dlg();
	CEdit m_EDIT_I2CM_ADDRESS;
	CShadeButtonST	m_I2CMbtns[2];
	CButton m_RADIODevice[2];
	BOOL m_bInit;
	int  m_CtrlCnt;
	CString ToolTipStr;
// Dialog Data
	enum { IDD = IDD_GPIO_MONITOR_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	void InitDialogWnd(bool);
	void I2CMSwitchLang(HINSTANCE tmpDll, int LanguageIdx);	
	afx_msg void OnBnClickedBtnGpioMonitorStart();
	afx_msg void OnBnClickedBtnGpioMonitorStop();
	BOOL SetTipText(UINT id, NMHDR *pTTTStruct, LRESULT *pResult);
protected:
	virtual void OnOK();
	virtual void OnCancel();
	HINSTANCE LangDll;
public:
	CButton m_CHECK_Read;
	CButton m_CHECK_Write;
	CButton m_CHECK_ACK;
	CButton m_CHECK_NACK;
};
