/**************************************************************************//**
 * @file     I2C0_Master_Dlg.cpp
 * @version  V1.00
 * $Revision: 1 $
 * $Date: 13/12/03 11:27a $
 * @brief    NuBridge I2C0 Master Main Dialog
 *
 * @note
 * Copyright (C) 2013 Nuvoton Technology Corp. All rights reserved.
 *
 ******************************************************************************/
// I2C0_Master_Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "NuBridge.h"
#include "I2C0_Master_Dlg.h"

#include "NuDlgMessage.h"
#include "NuWidget.h"
// I2C0_Master_Dlg dialog

IMPLEMENT_DYNAMIC(I2C0_Master_Dlg, CDialog)
CFont cf_I2C0;
int I2C0_FontHeight = 16;
I2C0_Master_Dlg::I2C0_Master_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(I2C0_Master_Dlg::IDD, pParent)
{
	m_bInit = FALSE;
	m_CtrlCnt = 0;
}

I2C0_Master_Dlg::~I2C0_Master_Dlg()
{
}

void I2C0_Master_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_EDIT_I2C0, m_EDIT_I2C0);

	DDX_Control(pDX, IDC_BTN_I2C0_MODE, m_I2C0btns[0]);
	DDX_Control(pDX, IDC_BTN_I2C0_GO,  m_I2C0btns[1]);
	DDX_Control(pDX, IDC_BTN_I2C0_LOAD, m_I2C0btns[2]);
	DDX_Control(pDX, IDC_BTN_I2C0_PARM, m_I2C0btns[3]);
	DDX_Control(pDX, IDC_BTN_I2C0_CLR, m_I2C0btns[4]);
	DDX_Control(pDX, IDC_BTN_I2C0_FIND, m_I2C0btns[5]);
	DDX_Control(pDX, IDC_BTN_I2C0_DISABLE, m_I2C0btns[6]);
	DDX_Control(pDX, IDC_BTN_I2C0_SAVE, m_I2C0btns[7]);
	DDX_Control(pDX, IDC_I2C0_SCRIPT_HELP, m_ScriptHelpBtn);
}


BEGIN_MESSAGE_MAP(I2C0_Master_Dlg, CDialog)
	ON_BN_CLICKED(IDC_BTN_I2C0_MODE, &I2C0_Master_Dlg::OnBnClickedBtnI2c0Mode)
	ON_BN_CLICKED(IDC_BTN_I2C0_DISABLE, &I2C0_Master_Dlg::OnBnClickedBtnI2c0Disable)
	ON_BN_CLICKED(IDC_BTN_I2C0_CLR, &I2C0_Master_Dlg::OnBnClickedBtnI2c0Clr)
	ON_BN_CLICKED(IDC_BTN_I2C0_LOAD, &I2C0_Master_Dlg::OnBnClickedBtnI2c0Load)
	ON_BN_CLICKED(IDC_BTN_I2C0_GO, &I2C0_Master_Dlg::OnBnClickedBtnI2c0Go)
	ON_BN_CLICKED(IDC_BTN_I2C0_PARM, &I2C0_Master_Dlg::OnBnClickedBtnI2c0Parm)
	ON_BN_CLICKED(IDC_I2C0_SCRIPT_HELP, &I2C0_Master_Dlg::OnBnClickedI2c0ScriptHelp)
	ON_BN_CLICKED(IDC_BTN_I2C0_SAVE, &I2C0_Master_Dlg::OnBnClickedBtnI2c0Save)

	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, &I2C0_Master_Dlg::SetTipText)
END_MESSAGE_MAP()


// I2C0_Master_Dlg message handlers

BOOL I2C0_Master_Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CString csFontPath = _T("Courier new Bold.ttf"); 
	AddFontResource(csFontPath);
	cf_I2C0.CreateFont(I2C0_FontHeight,0,0,0,FW_NORMAL,FALSE, FALSE, 
				  FALSE,DEFAULT_CHARSET ,OUT_DEFAULT_PRECIS,
				  CLIP_DEFAULT_PRECIS,ANTIALIASED_QUALITY,
				  DEFAULT_PITCH, _T("Courier new Bold")); 
	
	m_EDIT_I2C0.SetFont(&cf_I2C0,true);


	HICON hlcon=AfxGetApp()->LoadIconW(IDR_SCRIPTHELP);
    m_ScriptHelpBtn.SetIcon(hlcon);

	InitDialogWnd(FALSE);
	EnableToolTips(TRUE);
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
void I2C0_Master_Dlg::InitDialogWnd(bool bShow)
{
	// Disable All Member
	if(!m_bInit)
	{
		int i = 0;
		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_MODE, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_GO, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_LOAD, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_CONFIG, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_CLR, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_FIND, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_STOP, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_SAVE, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_bInit = TRUE;
		m_CtrlCnt = i;
	}

	
	if(NuUsb.WinUsbNumber == 0)
	{
		// Disable All Member
		m_EDIT_I2C0.EnableWindow(FALSE);
		//m_ScriptHelpBtn.EnableWindow(FALSE);

		for(int i = 0; i < m_CtrlCnt; i++)
		{
			m_I2C0btns[i].EnableWindow(FALSE);
		}
	}
	else
	{
		m_I2C0btns[0].EnableWindow(bShow);

		m_EDIT_I2C0.EnableWindow(!bShow);
		//m_ScriptHelpBtn.EnableWindow(!bShow);
		for(int i = 1; i < m_CtrlCnt; i++)
		{
			m_I2C0btns[i].EnableWindow(!bShow);
		}
	}

	m_I2C0btns[5].ShowWindow(FALSE);   // Disable Find BTN
	//m_I2C0btns[7].ShowWindow(FALSE);   // Disable Save BTN

}
void I2C0_Master_Dlg::I2C0SwitchLang(HINSTANCE tmpDll, int LanguageIdx)
{
	CString text;
	int i;
    
	if(tmpDll && (LanguageIdx > 0))
	{
		text.LoadString(tmpDll, IDS_I2CSCRIPT);
		GetDlgItem(IDC_STATIC_I2C0_SCRIPT)->SetWindowText(text);
	}
	
	if(LanguageIdx == 1)
	{
		i = 0;
		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_MODE, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_GO, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_LOAD, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_CONFIG, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_CLR, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_FIND, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_STOP, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_SAVE, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();
	}
	else if(LanguageIdx == 2)
	{
		i = 0;
		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_MODE, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_GO, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_LOAD, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_CONFIG, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_CLR, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_FIND, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_STOP, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_SAVE, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();
	}
	else    // default language(English)
	{
		i = 0;
		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_MODE, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_GO, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_LOAD, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_CONFIG, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_CLR, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_FIND, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_STOP, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		m_I2C0btns[i].SetBitmaps(IDB_BITMAP_BTN_SAVE, RGB(0, 255, 0)); 
		m_I2C0btns[i++].DrawTransparent();

		GetDlgItem(IDC_STATIC_I2C0_SCRIPT)->SetWindowText(_T("I2C Script"));
	}
	LangDll = tmpDll;
}
void I2C0_Master_Dlg::OnBnClickedBtnI2c0Mode()
{
	// TODO: Add your control notification handler code here
	
	if(NuUsb.WinUsbNumber > 0)
	{
		GetParent()->SendMessage(WM_LOCK_SCREEN, (WPARAM)1 );
		InitDialogWnd(FALSE);
	
	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		InitDialogWnd(FALSE);
		return;
	}
}

void I2C0_Master_Dlg::OnBnClickedBtnI2c0Disable()
{
	// TODO: Add your control notification handler code here
	
	if(NuUsb.WinUsbNumber > 0)
	{
		GetParent()->SendMessage(WM_LOCK_SCREEN, (WPARAM)0);
		InitDialogWnd(TRUE);
	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		InitDialogWnd(FALSE);
		return;
	}
}

void I2C0_Master_Dlg::OnBnClickedBtnI2c0Clr()
{
	// TODO: Add your control notification handler code here
	m_EDIT_I2C0.SetWindowText(_T(""));
}

void I2C0_Master_Dlg::OnBnClickedBtnI2c0Load()
{
	// TODO: Add your control notification handler code here
	CFile File;
	UINT dwFileLen=0;
	CString m_strGetPathName;
	//CHAR *I2C_comm; 
	TCHAR *I2C_comm;
	UINT uBytesRead = 0;

	if(NuUsb.WinUsbNumber == 0)
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		return;
	}

	CFileDialog dlg(true, NULL, NULL, 0, _T("*.txt|*.TXT|*.*|*.*||"), this);
    if(dlg.DoModal() == IDOK)
	{
		m_strGetPathName = dlg.GetOFN().lpstrFile;
	}


	if (File.Open(m_strGetPathName,CFile::modeRead))
	{
		// Get file size
		dwFileLen = File.GetLength();
		
		// create new buffer for saving	
		I2C_comm = new TCHAR[dwFileLen + 1];
		memset(I2C_comm, 0 ,sizeof(TCHAR) * (dwFileLen + 1));
		I2C_comm[dwFileLen]='\0'; // add this line to avoid display error

		uBytesRead = File.Read(I2C_comm, dwFileLen);
		
		File.Close();
	}
	else
	{
		return;
	}

	CString strSource(I2C_comm);
	m_EDIT_I2C0.SetWindowText(strSource);

	I2C_comm = NULL;
}

UCHAR ScriptDataI2C[1024];
int scIdxI2C = 0;

void I2C0_Master_Dlg::OnBnClickedBtnI2c0Go()
{
	CString strScript;
	CString resToken;
	int curPos = 0;
	
	InitI2cMasterSts();

	// Get whole user input
	m_EDIT_I2C0.GetWindowText(strScript);

	resToken = strScript.Tokenize(_T(" \r\n\t"), curPos);
	
	int status = -1;	// intial status
	
	UCHAR val;
	
	USHORT CmdCnt = 0;
	UCHAR  dataCnt = 0;
	
	CString strErr;
	
	bool bWriteFlag = 0;
	
	ScriptDataI2C[0] = 0;
	scIdxI2C = 1;
	
	TCHAR *pszStopString;

	while(resToken != _T(""))
	{
		if(0 == resToken.Find(_T(";")))
		{
			resToken = strScript.Tokenize(_T("\r\n"), curPos);
			
			if(resToken != _T(""))
				goto PARSING_NEXT_TOKEN;
			else
				goto PARSING_COMPLETE;
		}
	
	
	
		if(resToken.GetLength() > 2)
		{
			strErr.Format(_T("Format Error: %s"), resToken);
			MessageBox(strErr);
			return;
		}
		
		resToken.MakeUpper();

		//TRACE(_T("Get item: %s\n"), resToken);
		
		switch(status)
		{
			case -1: // Not start
				if(resToken == _T("W"))
				{
					ScriptDataI2C[scIdxI2C++] = 'W';
					bWriteFlag = 1;
				}
				else if(resToken == _T("R"))
				{
					ScriptDataI2C[scIdxI2C++] = 'R';
					bWriteFlag = 0;
				}
				else
				{
					AfxMessageBox(_T("Format Error"));
					return;
				}
				
				CmdCnt++;
				
				status = 0;
				
				break;
				
			case 0: // Read or Write token found
				val = _tcstoul(resToken, &pszStopString, 16);		

				if( _tcsicmp(pszStopString, _T("")) != 0 ) {
					// OK. We reach here.
					strErr.Format(_T("%s is not a valid I2C Addres"), resToken);
					MessageBox(strErr);
					return;
				}
				
				if(val & 0x80)
				{
					MessageBox(_T("Out of 7-Bit Range"));
					return;
				}
				
				//	I2C 7-Bit Address
				ScriptDataI2C[scIdxI2C++] = val;
				
				status = 1;
				break;



			case 1: // Address recorded
				val = _tcstoul(resToken, &pszStopString, 16);		

				if( _tcsicmp(pszStopString, _T("")) != 0 ) {
					// OK. We reach here.
					strErr.Format(_T("%s is not a valid Data Count"), resToken);
					MessageBox(strErr);
					return;
				}
				
				//	I2C Data Count
				dataCnt = val;
				ScriptDataI2C[scIdxI2C++] = dataCnt;
				
				if(bWriteFlag)
					status = 2;
				else
					status = -1;
				break;
				
			case 2: // Parsing Write data
			
				TCHAR *pszStopString;
				
				val = _tcstoul(resToken, &pszStopString, 16);		

				if( _tcsicmp(pszStopString, _T("")) != 0 ) {
					// OK. We reach here.
					strErr.Format(_T("%s is not a valid Hex Data"), resToken);
					MessageBox(strErr);
					return;
				}
				
				//	I2C Hex Data
				if(dataCnt)
				{
					ScriptDataI2C[scIdxI2C++] = val;
				}
				
				dataCnt--;
				
				if(dataCnt == 0)
					status = -1;
				
				break;
			
			default:
				MessageBox(_T("Exception Occured"));
		}
PARSING_NEXT_TOKEN:		
		resToken = strScript.Tokenize(_T(" \r\n\t"), curPos);
	}

PARSING_COMPLETE:	


	if(status != -1)
	{
		MessageBox(_T("Unexpected End of Command"));
		return;
	}

	// Command Count
	ScriptDataI2C[0] = CmdCnt;

	NuUsb.NU_Data2Bridge(ScriptDataI2C, scIdxI2C, MODE_I2C0_MASTER);
}

void I2C0_Master_Dlg::OnBnClickedBtnI2c0Parm()
{
	// TODO: Add your control notification handler code here
	I2C0_Master_Para_Dlg I2C0ParmDlg;
	
	if(NuUsb.WinUsbNumber > 0)
	{
		I2C0ParmDlg.DoModal();
	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
	}
}

void I2C0_Master_Dlg::OnOK()
{
	// TODO: Add your specialized code here and/or call the base class
	//CDialog::OnOK();
}

void I2C0_Master_Dlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class
	//CDialog::OnCancel();
}

void I2C0_Master_Dlg::OnBnClickedI2c0ScriptHelp()
{
	// TODO: Add your control notification handler code here
	CString strSource1, strSource2, strSource3, strSource;
	I2C0_Script_Help I2C0ScriptHelpDlg;
/*	
	if(NuUsb.WinUsbNumber > 0)
	{
		I2C0ScriptHelpDlg.DoModal();

		strSource1 =  _T("w 51 12 0 0 00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f");	
		strSource2 =  _T("w 51 2 0 0");
		strSource3 =  _T("r 51 a");

		strSource.Format(_T("%s\r\n%s\r\n%s"), strSource1, strSource2, strSource3);
		m_EDIT_I2C0.SetWindowText(strSource);
	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
	}	
*/
	I2C0ScriptHelpDlg.DoModal();

	strSource1 =  _T("w 51 12 0 0 00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f");	
	strSource2 =  _T("w 51 2 0 0");
	strSource3 =  _T("r 51 a");

	strSource.Format(_T("%s\r\n%s\r\n%s"), strSource1, strSource2, strSource3);
	m_EDIT_I2C0.SetWindowText(strSource);
}

void I2C0_Master_Dlg::OnBnClickedBtnI2c0Save()
{
	// TODO: Add your control notification handler code here
	CFile File;
	CString m_strGetPathName;
	CString strScript;
	UINT dwFileLen=0;
	UINT uBytesRead = 0;
	TCHAR *OutScript; 
	
	if(NuUsb.WinUsbNumber == 0)
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		return;
	}

	CFileDialog dlg(FALSE, _T("txt"), _T("*.txt"), OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,  _T("*.txt|*.TXT|*.*|*.*||"));   

	if(dlg.DoModal() == IDOK)
	{
		m_strGetPathName = dlg.GetOFN().lpstrFile;     
	}


	m_EDIT_I2C0.GetWindowText(strScript);

	if (File.Open(m_strGetPathName, CFile::modeCreate | CFile::modeWrite))
	{				      
		
		dwFileLen = strScript.GetLength();

		OutScript = new TCHAR[dwFileLen + 1];
		memset(OutScript, 0 ,sizeof(TCHAR) * (dwFileLen + 1));

		OutScript = strScript.GetBuffer(strScript.GetLength());
		strScript.ReleaseBuffer();

		//File.Write(strScript, strScript.GetLength()*2);
		File.Write(OutScript, sizeof(TCHAR)*strScript.GetLength() * 2);
		File.Flush();

		File.Close();
	}
	else
	{
		return;
	}
	
	OutScript = NULL;
}

BOOL I2C0_Master_Dlg::SetTipText(UINT id, NMHDR *pTTTStruct, LRESULT *pResult)
{
	TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pTTTStruct;          
	UINT nID = pTTTStruct->idFrom; 

	if (pTTT->uFlags & TTF_IDISHWND)  
	{
		nID = ::GetDlgCtrlID((HWND)nID);
		if (NULL == nID)
			return FALSE;
		
		switch(nID)
		{
			case IDC_I2C0_SCRIPT_HELP:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Show Script Command example.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_HELP);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}	
			break;  
				
			case IDC_BTN_I2C0_PARM:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Config I2C Master parameter.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_I2C0_CONFIG);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}
			break;
			
			case IDC_BTN_I2C0_MODE:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Start I2C Master.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_I2C0_MODE);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}	
			break;
			
			case IDC_BTN_I2C0_DISABLE:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Stop I2C Master.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_I2C0_DISABLE);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}				
			break;
			
			case IDC_BTN_I2C0_LOAD:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Load I2C script from PC.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_I2C0_LOAD);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}				
			break;
			
			case IDC_BTN_I2C0_SAVE:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Save I2C script to PC.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_I2C0_SAVE);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}				
			break;
			
			case IDC_BTN_I2C0_GO:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Send I2C master data to NuBridge.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_I2C0_GO);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}				
			break;
			
			case IDC_BTN_I2C0_CLR:				
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Clear script.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_CLEAR);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}
			break;			
			

			default:
				break;
		}

		return TRUE;
	}  
	return FALSE;    
}