/*---------------------------------------------------------------------------------------------------------*/
/*																										   */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.										   */
/*																										   */
/*---------------------------------------------------------------------------------------------------------*/

#pragma once
#include "afxwin.h"
#include <NuWinUsb.h>
#include <CmdEdit.h>
#include "I2C0_Master_Para_Dlg.h"
#include "I2C0_Script_Help.h"
#include "BtnST.h"
#include "ShadeButtonST.h"

// I2C0_Master_Dlg dialog

class I2C0_Master_Dlg : public CDialog
{
	DECLARE_DYNAMIC(I2C0_Master_Dlg)

public:
	I2C0_Master_Dlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~I2C0_Master_Dlg();
	CCmdEdit m_EDIT_I2C0;
	CShadeButtonST m_I2C0btns[8];
	BOOL m_bInit;
	int  m_CtrlCnt;
	CString ToolTipStr;
	

// Dialog Data
	enum { IDD = IDD_I2C0_MASTER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	
	void InitDialogWnd(bool);
	void I2C0SwitchLang(HINSTANCE tmpDll, int LanguageIdx);
	afx_msg void OnBnClickedBtnI2c0Mode();
	afx_msg void OnBnClickedBtnI2c0Disable();
	afx_msg void OnBnClickedBtnI2c0Clr();
	afx_msg void OnBnClickedBtnI2c0Load();
	afx_msg void OnBnClickedBtnI2c0Go();
	afx_msg void OnBnClickedBtnI2c0Parm();
	BOOL SetTipText(UINT id, NMHDR *pTTTStruct, LRESULT *pResult);
protected:
	virtual void OnOK();
	virtual void OnCancel();
	HINSTANCE LangDll;
public:
	afx_msg void OnBnClickedI2c0ScriptHelp();
	CButton m_ScriptHelpBtn;
	afx_msg void OnBnClickedBtnI2c0Save();
};
