/**************************************************************************//**
 * @file     I2C0_Master_Para_Dlg.cpp
 * @version  V1.00
 * $Revision: 1 $
 * $Date: 13/12/03 11:27a $
 * @brief    NuBridge I2C0 Master Parameter Setting Dialog 
 *
 * @note
 * Copyright (C) 2013 Nuvoton Technology Corp. All rights reserved.
 *
 ******************************************************************************/
// I2C0_Master_Para_Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "NuBridge.h"
#include "I2C0_Master_Para_Dlg.h"


// I2C0_Master_Para_Dlg dialog
extern int m_iLanguage;
IMPLEMENT_DYNAMIC(I2C0_Master_Para_Dlg, CDialog)

I2C0_Master_Para_Dlg::I2C0_Master_Para_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(I2C0_Master_Para_Dlg::IDD, pParent)
{

}

I2C0_Master_Para_Dlg::~I2C0_Master_Para_Dlg()
{
}

void I2C0_Master_Para_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_I2C0_CLK, m_COMBO_I2C0_CLK);
	DDX_Control(pDX, IDC_BTN_I2C0_GET, m_I2C0Parmbtns[0]);
	DDX_Control(pDX, IDC_BTN_I2C0_SET, m_I2C0Parmbtns[1]);
}


BEGIN_MESSAGE_MAP(I2C0_Master_Para_Dlg, CDialog)
	ON_BN_CLICKED(IDC_BTN_I2C0_GET, &I2C0_Master_Para_Dlg::OnBnClickedBtnI2c0Get)
	ON_BN_CLICKED(IDC_BTN_I2C0_SET, &I2C0_Master_Para_Dlg::OnBnClickedBtnI2c0Set)
END_MESSAGE_MAP()


// I2C0_Master_Para_Dlg message handlers

BOOL I2C0_Master_Para_Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	I2C0ParmSwitchLang(m_iLanguage);

	m_COMBO_I2C0_CLK.AddString(_T("100 kHz"));
	m_COMBO_I2C0_CLK.AddString(_T("200 kHz"));
	m_COMBO_I2C0_CLK.AddString(_T("400 kHz"));
	OnBnClickedBtnI2c0Get();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
void I2C0_Master_Para_Dlg::I2C0ParmSwitchLang(int LanguageIdx)
{		
	CString text;
    HMODULE hSubDLL;
	
	if(LanguageIdx == 1)
	{
		m_I2C0Parmbtns[0].SetBitmaps(IDB_BITMAP_CHT_BTN_GET, RGB(0, 255, 0)); 
		m_I2C0Parmbtns[0].DrawTransparent();

		m_I2C0Parmbtns[1].SetBitmaps(IDB_BITMAP_CHT_BTN_SET, RGB(0, 255, 0)); 
		m_I2C0Parmbtns[1].DrawTransparent();

		hSubDLL = LoadLibrary(_T("NuLang_zh-CHT.dll"));
	}
	else if(LanguageIdx == 2)
	{
		m_I2C0Parmbtns[0].SetBitmaps(IDB_BITMAP_CHS_BTN_GET, RGB(0, 255, 0)); 
		m_I2C0Parmbtns[0].DrawTransparent();

		m_I2C0Parmbtns[1].SetBitmaps(IDB_BITMAP_CHS_BTN_SET, RGB(0, 255, 0)); 
		m_I2C0Parmbtns[1].DrawTransparent(); 
		
		hSubDLL = LoadLibrary(_T("NuLang_zh-CHS.dll"));
	}
	else   // Default English
	{
		m_I2C0Parmbtns[0].SetBitmaps(IDB_BITMAP_BTN_GET, RGB(0, 255, 0)); 
		m_I2C0Parmbtns[0].DrawTransparent();

		m_I2C0Parmbtns[1].SetBitmaps(IDB_BITMAP_BTN_SET, RGB(0, 255, 0)); 
		m_I2C0Parmbtns[1].DrawTransparent();

		hSubDLL = LoadLibrary(_T("NuLang_en-US.dll"));
	}

	if (hSubDLL)
	{
		text.LoadString(hSubDLL, IDS_CLOCK);
		GetDlgItem(IDC_STATIC_I2C0_CLK)->SetWindowText(text);
	}
}
void I2C0_Master_Para_Dlg::OnBnClickedBtnI2c0Get()
{
	// TODO: Add your control notification handler code here
	m_COMBO_I2C0_CLK.SetCurSel(NuUsb.NU_GetI2C0Param() - 1);  // 1 ,2 ,3
}

void I2C0_Master_Para_Dlg::OnBnClickedBtnI2c0Set()
{
	// TODO: Add your control notification handler code here
	UCHAR  param_Clk;
	
	param_Clk = m_COMBO_I2C0_CLK.GetCurSel() + 1;   // 1 ,2, 3

	NuUsb.NU_SetI2C0Param(param_Clk);
	Sleep(2);
	OnOK();
}
