/*---------------------------------------------------------------------------------------------------------*/
/*																										   */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.										   */
/*																										   */
/*---------------------------------------------------------------------------------------------------------*/

// NuBridgeDlg.h : header file
//

#pragma once

#include <NuWinUsb.h>
#include "StackedWndCtrl.h"
#include "BtnST.h"
#include "ShadeButtonST.h"
#include "NuTabCtrl.h"
#include "afxcmn.h"
#include "afxwin.h"
#include "NuDlgMessage.h"
#include "ColorListCtrl.h"
// CNuBridgeDlg dialog
class CNuBridgeDlg : public CDialog
{
// Construction
public:
	CNuBridgeDlg(CWnd* pParent = NULL);	// standard constructor
	CWnd* ContentWnd(int iIndex, CWnd* pParent);

// Dialog Data
	enum { IDD = IDD_NUBRIDGE_DIALOG };
	CStackedWndCtrl	m_MainFrameWnd;
	CMenu m_Menu;
	
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;
	
	// Multiple language support
	HMODULE   hDLL;	

	// Generated message map functions
	virtual BOOL OnInitDialog();

	// Layout Setting (Main Menu Frame, Sub Setting Frame, Data Monitor Frame)
	// Main Menu Frame (Stack Style)
	BOOL InitMainStackIconWnd();


	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg LRESULT OnMyDeviceChange(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
public:
	CStatic m_LOGO;
	int m_DeviceId;
	CNuTabCtrl m_tabCtrl;
	CRect m_rSettingsRect;
	//CListCtrl m_MAIN_LIST;
	CColorListCtrl m_MAIN_LIST;
	CShadeButtonST	m_btnButtons[3];
	CButton m_RADIO_Device[4];
	
	int DeviceIdx;
	BOOL RadioValid[4];
	CString ToolTipStr;

	// USB Device Control
	CWinThread *m_pUsbReadThread;
	CWinThread *m_pListWriteThread;

	void StartUsbMonitor(void);
	void EndUsbMonitor(void);

	int SwitchUsbDevice(void);
	void ShowMainFrameRadio(BOOL bShow, UINT RadioNum);
	void DeviceRadioCheck(BOOL bShow);
	void SwitchLang(HINSTANCE tmpDll);
	void CNuBridgeDlg::DisableDevice(int devId);
	BOOL CNuBridgeDlg::SetTipText(UINT id, NMHDR *pTTTStruct, LRESULT *pResult);

protected:
	virtual void OnOK();
	virtual void OnCancel();
public:
	afx_msg void OnClose();
	afx_msg void OnBnClickedButtonConnect();

	afx_msg LRESULT OnTabClicked(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT LockScreen(WPARAM wParam, LPARAM /*lParam*/);
	afx_msg LRESULT LockListCtrl(WPARAM wParam, LPARAM /*lParam*/);
	afx_msg void OnTcnSelchangeMainTab(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedBtnUsbActive();
	afx_msg void OnLanguageUs();
	afx_msg void OnLanguageChinesetraditional();
	afx_msg void OnLanguageChinesesimple();
	afx_msg void OnBnClickedRadioD1();
	afx_msg void OnBnClickedRadioD2();
	afx_msg void OnBnClickedRadioD3();
	afx_msg void OnBnClickedRadioD4();
	afx_msg void OnBnClickedClear();

};
