// PWM_Capture_Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "NuBridge.h"
#include "PWM_Capture_Dlg.h"
#include "NuDlgMessage.h"
#include "NuWidget.h"
// PWM_Capture_Dlg dialog

IMPLEMENT_DYNAMIC(PWM_Capture_Dlg, CDialog)

#define PWMCapTest (0)   // for debug

extern int out_Byte3;
int period0, period1;
extern float duty0, duty1;

extern int PWMStatus;
extern int Edge0, FallWidth0, RiseWidth0, Edge1, FallWidth1, RiseWidth1;

int NoReceiveCnt = 0;
int edge_type0 = 0;
int edge_type1 = 0;

PWM_Capture_Dlg::PWM_Capture_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(PWM_Capture_Dlg::IDD, pParent)
{
	m_bInit = FALSE;
	m_CtrlCnt = 0;
}

PWM_Capture_Dlg::~PWM_Capture_Dlg()
{
}

void PWM_Capture_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PWMC_LISTCTRL, m_PWMCList);
	DDX_Control(pDX, IDC_BTN_PWMC_RUN, m_PWMCbtns[0]);
	DDX_Control(pDX, IDC_BTN_PWMC_DISABLE, m_PWMCbtns[1]);
	DDX_Control(pDX, IDC_BTN_PWMC_PARM, m_PWMCbtns[2]);
}


BEGIN_MESSAGE_MAP(PWM_Capture_Dlg, CDialog)
	ON_NOTIFY(NM_CLICK, IDC_PWMC_LISTCTRL, &PWM_Capture_Dlg::OnNMClickPwmcListctrl)
	ON_BN_CLICKED(IDC_BTN_PWMC_RUN, &PWM_Capture_Dlg::OnBnClickedBtnPwmcRun)
	ON_BN_CLICKED(IDC_BTN_PWMC_DISABLE, &PWM_Capture_Dlg::OnBnClickedBtnPwmcDisable)
	ON_BN_CLICKED(IDC_BTN_PWMC_PARM, &PWM_Capture_Dlg::OnBnClickedBtnPwmcParm)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// PWM_Capture_Dlg message handlers
BOOL b_PWM0flag = TRUE, b_PWM1flag = TRUE;
BOOL PWM_Capture_Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	InitDialogWnd(FALSE);
	EnableToolTips(TRUE);		
	
	m_PWMCcomBox.Create(WS_CHILD/*|WS_VISIBLE*/|CBS_DROPDOWNLIST|CBS_OEMCONVERT,CRect(0,0,30,30),this,0);
	m_PWMCcomBox.SetParent(&m_PWMCList);
	m_PWMCcomBox.AddString(_T("Falling"));
	m_PWMCcomBox.AddString(_T("Rising"));
	m_PWMCcomBox.AddString(_T("Both"));
	m_PWMCcomBox.SetFont(this->GetFont(),FALSE);
	
	BuildList();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
void PWM_Capture_Dlg::InitDialogWnd(bool bShow)
{
	// Disable All Member
	if(!m_bInit)
	{
		int i = 0;

		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_BTN_MODE, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();

		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_BTN_STOP, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();

		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_BTN_SET, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();

		m_bInit = TRUE;
		m_CtrlCnt = i;
	}

	if(NuUsb.WinUsbNumber == 0)
	{	
		for(int i = 0; i < m_CtrlCnt; i++)
		{
			m_PWMCbtns[i].EnableWindow(FALSE);
		}
		m_PWMCList.EnableWindow(FALSE);
	}
	else
	{
		m_PWMCbtns[0].EnableWindow(bShow);	
		m_PWMCList.EnableWindow(!bShow);
		for(int i = 1; i < m_CtrlCnt; i++)
		{
			m_PWMCbtns[i].EnableWindow(!bShow);
		}
	}	
}

void PWM_Capture_Dlg::PWMCSwitchLang(HINSTANCE tmpDll, int LanguageIdx)
{
	int i;
	if(LanguageIdx == 1)
	{
        i = 0;
		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_MODE, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();

		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_STOP, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();

		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_SET, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();
	}
	else if(LanguageIdx == 2)
	{
		i = 0;
		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_MODE, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();

		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_STOP, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();

		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_SET, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();
	}
	else
	{
		i = 0;
		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_BTN_MODE, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();

		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_BTN_STOP, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();

		m_PWMCbtns[i].SetBitmaps(IDB_BITMAP_BTN_SET, RGB(0, 255, 0)); 
		m_PWMCbtns[i++].DrawTransparent();
	}
	LangDll = tmpDll;
}

void PWM_Capture_Dlg::OnNMClickPwmcListctrl(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<NMITEMACTIVATE*>(pNMHDR);
	// TODO: Add your control notification handler code here

	NM_LISTVIEW  *pEditCtrl = (NM_LISTVIEW *)pNMHDR;
	CRect  EditRect;
	CRect  ComRect;
	
	ComboBoxHIDE();
	//column 1 -> Combobox
	if (pEditCtrl->iSubItem == 1)
	{   
		

		CString strCom;
		m_PWMCComItem = pEditCtrl->iItem;		
		m_PWMCList.GetSubItemRect(m_PWMCComItem,1,LVIR_BOUNDS,ComRect);
		strCom = m_PWMCList.GetItemText(m_PWMCComItem,1); 


		if(strCom == _T("Falling"))
			m_PWMCcomBox.SetCurSel(0);
		else if(strCom == _T("Rising"))
			m_PWMCcomBox.SetCurSel(1);
		else if(strCom == _T("Both"))
			m_PWMCcomBox.SetCurSel(2);


		m_PWMCcomBox.SetWindowText(strCom);
		ComRect.bottom = ComRect.top + 120;

		ComRect.SetRect(ComRect.left,ComRect.top,ComRect.left+m_PWMCList.GetColumnWidth(1),ComRect.bottom);
		m_PWMCcomBox.MoveWindow(&ComRect);
		m_PWMCcomBox.ShowWindow(SW_SHOW);
		m_PWMCcomBox.SetFocus();   

	}

	*pResult = 0;
}
void PWM_Capture_Dlg::ComboBoxHIDE()
{
   
   if(m_PWMCcomBox.IsWindowVisible())
   {
	   CString str;
	   m_PWMCcomBox.GetWindowText(str);
	   m_PWMCList.SetItemText(m_PWMCComItem,1,str);
	   m_PWMCcomBox.ShowWindow(SW_HIDE);
   }   
}
void PWM_Capture_Dlg::OnOK()
{
	ComboBoxHIDE();
	//CDialog::OnOK();
}

void PWM_Capture_Dlg::OnBnClickedBtnPwmcRun()
{
	// TODO: Add your control notification handler code here
	InitPWM();
	ComboBoxHIDE();
	if(NuUsb.WinUsbNumber > 0)
	{
		GetParent()->SendMessage(WM_LOCK_SCREEN, (WPARAM)1);
		InitDialogWnd(FALSE);
	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		InitDialogWnd(FALSE);
		return;
	}
}

void PWM_Capture_Dlg::OnBnClickedBtnPwmcDisable()
{
	// TODO: Add your control notification handler code here
	ComboBoxHIDE();
	if(NuUsb.WinUsbNumber > 0)
	{
		GetParent()->SendMessage(WM_LOCK_SCREEN, (WPARAM)0);
		InitDialogWnd(TRUE);
		KillTimer(1);
	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		InitDialogWnd(FALSE);
		return;
	}
}

void PWM_Capture_Dlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class

	//CDialog::OnCancel();
}


#if(PWMCapTest)
void PWM_Capture_Dlg::OnBnClickedBtnPwmcParm()
{
	// TODO: Add your control notification handler code here
	UCHAR g_u8PWMTxBuf[300] = {0};
	CString strScript;
	int CMRtmp = 0, cnt = 0; // Reset Line position	

	ComboBoxHIDE();
	
	g_u8PWMTxBuf[cnt++] = 0x04;//cmd cnt

	//PWM2 output  // PWM Capture 1
	g_u8PWMTxBuf[cnt++]  = 0x24;
	g_u8PWMTxBuf[cnt++]  = 0x02;
	g_u8PWMTxBuf[cnt++]  = 0x09;
	g_u8PWMTxBuf[cnt++]  = 0xD0;
	g_u8PWMTxBuf[cnt++]  = 0x39;
	g_u8PWMTxBuf[cnt++]  = 0x78;
	g_u8PWMTxBuf[cnt++]  = 0x28;
	g_u8PWMTxBuf[cnt++]  = 0x01;
	g_u8PWMTxBuf[cnt++]  = 0x80;


	//PWM3 output // PWM Capture 0
	g_u8PWMTxBuf[cnt++]  = 0x34;
	g_u8PWMTxBuf[cnt++]  = 0x02;
	g_u8PWMTxBuf[cnt++]  = 0x09;
	g_u8PWMTxBuf[cnt++]  = 0xD0;
	g_u8PWMTxBuf[cnt++]  = 0x39;
	g_u8PWMTxBuf[cnt++]  = 0x90;
	g_u8PWMTxBuf[cnt++]  = 0x0B;
	g_u8PWMTxBuf[cnt++]  = 0x01;
	g_u8PWMTxBuf[cnt++]  = 0x80;
  

	m_PWMCbtns[2].EnableWindow(0); 
	m_PWMCList.EnableWindow(0);

	b_PWM0flag = m_PWMCList.GetCheck(0);
	b_PWM1flag = m_PWMCList.GetCheck(1);
	if(b_PWM0flag) // PWM 0 Capture
	{
		g_u8PWMTxBuf[cnt++] = 0x04; // Byte1 Channel
		g_u8PWMTxBuf[cnt++] = 0x02; // Byte2 CLK_SRC
		g_u8PWMTxBuf[cnt++] = 0x09; // Byte3 prescaler

		// CNR
		g_u8PWMTxBuf[cnt++] = 0xFF; // Byte4 CNR low byte
		g_u8PWMTxBuf[cnt++] = 0xFF; // Byte5 CNR high byte
		g_u8PWMTxBuf[cnt++] = 0x00; // Byte6 CMR low byte
		g_u8PWMTxBuf[cnt++] = 0x00; // Byte7 CMR high byte

		// Mode
		//strScript = m_PWMCList.GetItemText(0 , 2);
		strScript = m_PWMCList.GetItemText(0 , 1);
		if(strScript == _T("Falling"))
		{
			g_u8PWMTxBuf[cnt++] = 0x05;
			edge_type0 = 0;
		}
		else if(strScript == _T("Rising"))
		{
			g_u8PWMTxBuf[cnt++] = 0x03;	
			edge_type0 = 1;
		}
		else 
		{
			g_u8PWMTxBuf[cnt++] = 0x07;	
			edge_type0 = 2;
		}
	}

	if(b_PWM1flag) // PWM 1 Capture
	{
		g_u8PWMTxBuf[cnt++] = 0x14; // Byte1 Channel
		g_u8PWMTxBuf[cnt++] = 0x02; // Byte2 CLK_SRC
		g_u8PWMTxBuf[cnt++] = 0x09; // Byte3 prescaler

		// CNR
		g_u8PWMTxBuf[cnt++] = 0xFF; // Byte4 CNR low byte
		g_u8PWMTxBuf[cnt++] = 0xFF; // Byte5 CNR high byte
		g_u8PWMTxBuf[cnt++] = 0x00; // Byte6 CMR low byte
		g_u8PWMTxBuf[cnt++] = 0x00; // Byte7 CMR high byte

		// Mode
		strScript = m_PWMCList.GetItemText(1 , 1);
		if(strScript == _T("Falling"))
		{
			g_u8PWMTxBuf[cnt++] = 0x05;
			edge_type1 = 0;
		}
		else if(strScript == _T("Rising"))
		{
			g_u8PWMTxBuf[cnt++] = 0x03;	
			edge_type1 = 1;
		}
		else 
		{
			g_u8PWMTxBuf[cnt++] = 0x07;	
			edge_type1 = 2;	
		}
	}
	
/*
						   // 7 6 5 4 3 2 1 0
	g_u8PWMTxBuf[0] = 0x01;//cmd cnt
	//PWM1 capture enable
	g_u8PWMTxBuf[1] = 0x14;//bit 0~2: divider, bit 3: Align, bit 4~5: Nchan  
	g_u8PWMTxBuf[2] = 0x02;//CLK_SRC(don't change)  bit 4~7: CLK_SRC_H, bit 0~3: CLK_SRC_L  
	g_u8PWMTxBuf[3] = 0x09;//prescaler(don't change)
	g_u8PWMTxBuf[4] = 0xFF;//CNR(Low byte)
	g_u8PWMTxBuf[5] = 0xFF;//CNR(High byte)
	g_u8PWMTxBuf[6] = 0x00;//CMR(Low byte)
	g_u8PWMTxBuf[7] = 0x00;//CMR(High byte)
	g_u8PWMTxBuf[8] = 0x07;//bit 0:Mode ,bit 1: Enable Rising latch, bit 2: Enable Falling latch
*/

	NuUsb.NU_Data2Bridge(g_u8PWMTxBuf, cnt, MODE_PWM);
	
	SetTimer(1,200,NULL);

}

#else
void PWM_Capture_Dlg::OnBnClickedBtnPwmcParm()
{
	// TODO: Add your control notification handler code here
	UCHAR g_u8PWMTxBuf[300] = {0};
	CString strScript;
	int CMRtmp = 0, cnt = 0; // Reset Line position	

	ComboBoxHIDE();
	
	m_PWMCbtns[2].EnableWindow(0); 
	m_PWMCList.EnableWindow(0);

	b_PWM0flag = m_PWMCList.GetCheck(0);
	b_PWM1flag = m_PWMCList.GetCheck(1);

	if(b_PWM0flag & b_PWM1flag)
		g_u8PWMTxBuf[cnt++] = 0x02;//cmd cnt
	else
		g_u8PWMTxBuf[cnt++] = 0x01;//cmd cnt	
	
	if(b_PWM0flag) // PWM 0 Capture
	{
		g_u8PWMTxBuf[cnt++] = 0x04; // Byte1 Channel
		g_u8PWMTxBuf[cnt++] = 0x02; // Byte2 CLK_SRC
		g_u8PWMTxBuf[cnt++] = 0x09; // Byte3 prescaler

		// CNR
		g_u8PWMTxBuf[cnt++] = 0xFF; // Byte4 CNR low byte
		g_u8PWMTxBuf[cnt++] = 0xFF; // Byte5 CNR high byte
		g_u8PWMTxBuf[cnt++] = 0x00; // Byte6 CMR low byte
		g_u8PWMTxBuf[cnt++] = 0x00; // Byte7 CMR high byte

		// Mode
		strScript = m_PWMCList.GetItemText(0 , 1);
		if(strScript == _T("Falling"))
		{
			g_u8PWMTxBuf[cnt++] = 0x05;
			edge_type0 = 0;
		}
		else if(strScript == _T("Rising"))
		{
			g_u8PWMTxBuf[cnt++] = 0x03;	
			edge_type0 = 1;
		}
		else 
		{
			g_u8PWMTxBuf[cnt++] = 0x07;	
			edge_type0 = 2;
		}
	}

	if(b_PWM1flag) // PWM 1 Capture
	{
		g_u8PWMTxBuf[cnt++] = 0x14; // Byte1 Channel
		g_u8PWMTxBuf[cnt++] = 0x02; // Byte2 CLK_SRC
		g_u8PWMTxBuf[cnt++] = 0x09; // Byte3 prescaler

		// CNR
		g_u8PWMTxBuf[cnt++] = 0xFF; // Byte4 CNR low byte
		g_u8PWMTxBuf[cnt++] = 0xFF; // Byte5 CNR high byte
		g_u8PWMTxBuf[cnt++] = 0x00; // Byte6 CMR low byte
		g_u8PWMTxBuf[cnt++] = 0x00; // Byte7 CMR high byte

		// Mode
		strScript = m_PWMCList.GetItemText(1 , 1);
		if(strScript == _T("Falling"))
		{
			g_u8PWMTxBuf[cnt++] = 0x05;
			edge_type1 = 0;
		}
		else if(strScript == _T("Rising"))
		{
			g_u8PWMTxBuf[cnt++] = 0x03;	
			edge_type1 = 1;
		}
		else 
		{
			g_u8PWMTxBuf[cnt++] = 0x07;	
			edge_type1 = 2;	
		}
	}
	
/*
						   // 7 6 5 4 3 2 1 0
	g_u8PWMTxBuf[0] = 0x01;//cmd cnt
	//PWM1 capture enable
	g_u8PWMTxBuf[1] = 0x14;//bit 0~2: divider, bit 3: Align, bit 4~5: Nchan  
	g_u8PWMTxBuf[2] = 0x02;//CLK_SRC(don't change)  bit 4~7: CLK_SRC_H, bit 0~3: CLK_SRC_L  
	g_u8PWMTxBuf[3] = 0x09;//prescaler(don't change)
	g_u8PWMTxBuf[4] = 0xFF;//CNR(Low byte)
	g_u8PWMTxBuf[5] = 0xFF;//CNR(High byte)
	g_u8PWMTxBuf[6] = 0x00;//CMR(Low byte)
	g_u8PWMTxBuf[7] = 0x00;//CMR(High byte)
	g_u8PWMTxBuf[8] = 0x07;//bit 0:Mode ,bit 1: Enable Rising latch, bit 2: Enable Falling latch
*/


	NuUsb.NU_Data2Bridge(g_u8PWMTxBuf, cnt, MODE_PWM);
	
	SetTimer(1,200,NULL);

}

#endif
void PWM_Capture_Dlg::BuildList(void)
{
	CRect m_rect;
	m_PWMCList.GetWindowRect(&m_rect);
	ScreenToClient(m_rect);
	m_PWMCList.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT| LVS_EX_CHECKBOXES);
	
	int w = m_rect.right - m_rect.left;
	m_PWMCList.InsertColumn(0,_T("#"),LVCFMT_LEFT, w/3 - 40);
	m_PWMCList.InsertColumn(1,_T("Capture Mode"),LVCFMT_LEFT, w/3 * 2 + 40);

	m_PWMCList.InsertItem(0,_T("PWM 0"));
	m_PWMCList.SetCheck(0, TRUE);
	m_PWMCList.SetItemText(0,1,_T("Falling"));

	m_PWMCList.InsertItem(1,_T("PWM 1"));
	m_PWMCList.SetCheck(1, TRUE);
	m_PWMCList.SetItemText(1,1,_T("Falling"));
	
    PWMCrowCount = m_PWMCList.GetItemCount(); 
}

void PWM_Capture_Dlg::SquareWave(CDC *pDC, int x, int y, int W, float duty, int sec)
{
	CString s;
		
	pDC->MoveTo(x, (y + 50));  
	pDC->LineTo(x + (W * (1 - duty)), (y + 50));

	pDC->MoveTo(x + (W * (1 - duty)), (y + 50));
	pDC->LineTo(x + (W * (1 - duty)), (y + 11));

	pDC->MoveTo(x + (W * (1 - duty)), (y + 11));
	pDC->LineTo(x + (W * duty) + (W * (1 - duty)), (y + 11));

	pDC->MoveTo(x + (W * duty) + (W * (1 - duty)), (y + 11));
	pDC->LineTo(x + (W * duty) + (W * (1 - duty)), (y + 50));
}

void PWM_Capture_Dlg::DrawRect(CDC *pDC, int x, int y, int W)
{
	CString s;
		
	pDC->MoveTo(x, (y + 50));  
	pDC->LineTo(x + (W * 2)+ 40, (y + 50));

	pDC->MoveTo(x, (y + 11));
	pDC->LineTo(x + (W * 2) + 40, (y + 11));
	
	pDC->MoveTo(x + 80, (y + 50));
	pDC->LineTo(x + 80, (y + 11));
	
	pDC->MoveTo(x + 160, (y + 50));
	pDC->LineTo(x + 160, (y + 11));
	
	pDC->MoveTo(x + 240, (y + 50));
	pDC->LineTo(x + 240, (y + 11));
	
	pDC->MoveTo(x + 320, (y + 50));
	pDC->LineTo(x + 320, (y + 11));
}

void PWM_Capture_Dlg::ShowDrawWave(CDC *pDC, int Chanel, int WidthF, int WidthR)
{
	UpdateData(TRUE);

    CRect rect;
	CString str;

	CWnd* pWnd;
	int m_left,m_top,m_right,m_bottom;
	
	if(Chanel == 0)
		pWnd = GetDlgItem(IDC_WAVE);
	else
		pWnd = GetDlgItem(IDC_WAVE1);
		
	pWnd->GetClientRect(&rect);  
	pDC->Rectangle(&rect);

    
    m_left = rect.left + 70;
	m_top = rect.top;
	m_right = rect.right-29;
	m_bottom = rect.bottom-20;

	CPen* pPenBlue = new CPen;
	pPenBlue->CreatePen(PS_SOLID,3,RGB(0,0, 255));
	
	CGdiObject* pOldPen = pDC->SelectObject(pPenBlue);	

	CString s;
	
	if(Chanel == 0)
	{
		pDC->TextOut(rect.left + 5, m_top + 15, _T("PWM 0"));			
		
		if(edge_type0 == 2)  // both
		{		
			SquareWave(pDC, m_left, m_top, 160, duty0, 0);
			
			s.Format(_T("%d us"),WidthF);
			pDC->TextOut(m_left + 2 + (160 * (1- duty0)), m_top + 15, s);
			
			s.Format(_T("%d us"), WidthR);
			pDC->TextOut(m_left + 2 , m_top + 25, s);
			
			SquareWave(pDC, (m_left + 160), m_top, 160, duty0, 0);	
		
			pDC->MoveTo(m_left + 320, (m_top + 50));  
			pDC->LineTo(m_left + 320 + (160 * (1 - duty0)), (m_top + 50));
		}
		else if(edge_type0 == 1)  // rising
		{		
			DrawRect(pDC, m_left, m_top, 160);			
			s.Format(_T("%d us"), WidthR);
			pDC->TextOut(m_left + 6 , m_top + 25, s);
			pDC->TextOut(m_left + 166 , m_top + 25, s);
		}
		else				// falling
		{	
			DrawRect(pDC, m_left, m_top, 160);		
			s.Format(_T("%d us"),WidthF);		
			pDC->TextOut(m_left + 6 , m_top + 25, s);
			pDC->TextOut(m_left + 166 , m_top + 25, s);
		}				
	}
	else if(Chanel == 1)
	{
		pDC->TextOut(rect.left + 5, m_top + 15, _T("PWM 1"));
		
		if(edge_type1 == 2)  // both
		{		
			SquareWave(pDC, m_left, m_top, 160, duty1, 0);
			
			s.Format(_T("%d us"),WidthF);
			pDC->TextOut(m_left + 2 + (160 * (1- duty1)), m_top + 15, s);
			
			s.Format(_T("%d us"), WidthR);
			pDC->TextOut(m_left + 2 , m_top + 25, s);
			
			SquareWave(pDC, (m_left + 160), m_top, 160, duty1, 0);	
		
			pDC->MoveTo(m_left + 320, (m_top + 50));  
			pDC->LineTo(m_left + 320 + (160 * (1 - duty1)), (m_top + 50));
		}
		else if(edge_type1 == 1)  // rising
		{		
			DrawRect(pDC, m_left, m_top, 160);		
			s.Format(_T("%d us"),WidthR);		
			pDC->TextOut(m_left + 6 , m_top + 25, s);
			pDC->TextOut(m_left + 166 , m_top + 25, s);
		}
		else				// falling
		{	
			DrawRect(pDC, m_left, m_top, 160);		
			s.Format(_T("%d us"),WidthF);		
			pDC->TextOut(m_left + 6 , m_top + 25, s);
			pDC->TextOut(m_left + 166 , m_top + 25, s);
		}
	}
	
	pDC->SelectObject(pOldPen);	
	
	delete pPenBlue;
}

void PWM_Capture_Dlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	CRect rect0, rect1;
	
	CWnd* pWnd0 = GetDlgItem(IDC_WAVE);

	pWnd0->GetClientRect(&rect0);
	pDC0 = pWnd0->GetDC();	

	CBitmap memBitmap0;
	CBitmap* pOldBmp0 = NULL;
	memDC0.CreateCompatibleDC(pDC0);
	memBitmap0.CreateCompatibleBitmap(pDC0,rect0.right-rect0.left,rect0.bottom-rect0.top);
	pOldBmp0 = memDC0.SelectObject(&memBitmap0);
	
	
	CWnd* pWnd1 = GetDlgItem(IDC_WAVE1);

	pWnd1->GetClientRect(&rect1);
	pDC1 = pWnd1->GetDC();	

	CBitmap memBitmap1;
	CBitmap* pOldBmp1 = NULL;
	memDC1.CreateCompatibleDC(pDC1);
	memBitmap1.CreateCompatibleBitmap(pDC1,rect1.right-rect1.left,rect1.bottom-rect1.top);
	pOldBmp1 = memDC1.SelectObject(&memBitmap1);
	

	if(PWMStatus)
	{	
		if(PWMStatus & 0x01)
		{					
			ShowDrawWave(&memDC0, 0 , FallWidth0, RiseWidth0);			
			pDC0->BitBlt(0,0,rect0.Width(),rect0.Height(),&memDC0,0,0,SRCCOPY);
		}		
		if(PWMStatus & 0x02)
		{
			ShowDrawWave(&memDC1, 1 , FallWidth1, RiseWidth1);
			pDC1->BitBlt(0,0,rect1.Width(),rect1.Height(),&memDC1,0,0,SRCCOPY);
		}	
		PWMStatus = 0;
		FallWidth0 = 0;
		RiseWidth0 = 0;
		FallWidth1 = 0;
		RiseWidth1 = 0;
	}
	else
	{   
		NoReceiveCnt++;
		if(NoReceiveCnt > 200)
		{
			KillTimer(1);
			NoReceiveCnt = 0;
			PWMStatus = 0;
			FallWidth0 = 0;
			RiseWidth0 = 0;
			FallWidth1 = 0;
			RiseWidth1 = 0;
		}
	}

	memDC0.SelectObject(pOldBmp0);
	memDC0.DeleteDC();
	memBitmap0.DeleteObject();
	
	memDC1.SelectObject(pOldBmp1);
	memDC1.DeleteDC();
	memBitmap1.DeleteObject();


	CDialog::OnTimer(nIDEvent);
}
