/**************************************************************************//**
 * @file     SPI0_Master_Dlg.cpp
 * @version  V1.00
 * $Revision: 1 $
 * $Date: 13/12/03 11:27a $
 * @brief    NuBridge SPI0 Master Main Dialog
 *
 * @note
 * Copyright (C) 2013 Nuvoton Technology Corp. All rights reserved.
 *
 ******************************************************************************/
// SPI0_Master_Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "NuBridge.h"
#include "SPI0_Master_Dlg.h"
#include "SPI0_Script_Help_Dlg.h"

// Parent
#include "NuTabCtrl.h"

#include "NuDlgMessage.h"
#include "NuBridgeDlg.h"
#include "NuWidget.h"

extern int m_iLanguage;
// SPI0_Master_Dlg dialog





IMPLEMENT_DYNAMIC(SPI0_Master_Dlg, CDialog)

SPI0_Master_Dlg::SPI0_Master_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(SPI0_Master_Dlg::IDD, pParent)
{
	m_bInit = FALSE;
	m_CtrlCnt = 0;
}

SPI0_Master_Dlg::~SPI0_Master_Dlg()
{
}

void SPI0_Master_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_SPI0, m_EDIT_SPI0);
	DDX_Control(pDX, IDC_BTN_SPI0_MODE, m_SPI0btns[0]);
	DDX_Control(pDX, IDC_BTN_SPI0_GO, m_SPI0btns[1]); 
	DDX_Control(pDX, IDC_BTN_SPI0_LOAD, m_SPI0btns[2]); 
	DDX_Control(pDX, IDC_BTN_SPI0_CLR, m_SPI0btns[3]);
	DDX_Control(pDX, IDC_BTN_SPI0_PARM_INIT, m_SPI0btns[4]); 
	DDX_Control(pDX, IDC_BTN_SPI0_DISABLE, m_SPI0btns[5]);
	DDX_Control(pDX, IDC_BTN_SPI0_SAVE, m_SPI0btns[6]);
	DDX_Control(pDX, IDC_SPI0_SCRIPT_HELP_BTN, m_ScriptHelpBtn);
}


BEGIN_MESSAGE_MAP(SPI0_Master_Dlg, CDialog)
	
	ON_BN_CLICKED(IDC_BTN_SPI0_MODE, &SPI0_Master_Dlg::OnBnClickedBtnSpi0Mode)
	ON_BN_CLICKED(IDC_BTN_SPI0_DISABLE, &SPI0_Master_Dlg::OnBnClickedBtnSpi0Disable)
	ON_BN_CLICKED(IDC_BTN_SPI0_CLR, &SPI0_Master_Dlg::OnBnClickedBtnSpi0Clr)
	ON_BN_CLICKED(IDC_BTN_SPI0_LOAD, &SPI0_Master_Dlg::OnBnClickedBtnSpi0Load)
	ON_BN_CLICKED(IDC_BTN_SPI0_GO, &SPI0_Master_Dlg::OnBnClickedBtnSpi0Go)
	ON_BN_CLICKED(IDC_BTN_SPI0_PARM_INIT, &SPI0_Master_Dlg::OnBnClickedBtnSpi0ParmInit)
	ON_BN_CLICKED(IDC_SPI0_SCRIPT_HELP_BTN, &SPI0_Master_Dlg::OnBnClickedSpi0ScriptHelpBtn)
	ON_BN_CLICKED(IDC_BTN_SPI0_SAVE, &SPI0_Master_Dlg::OnBnClickedBtnSpi0Save)
	
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, &SPI0_Master_Dlg::SetTipText)
	ON_BN_CLICKED(IDC_RADIO_SPI0, &SPI0_Master_Dlg::OnBnClickedRadioSpi0)
	ON_BN_CLICKED(IDC_RADIO_SPI2, &SPI0_Master_Dlg::OnBnClickedRadioSpi2)
END_MESSAGE_MAP()


BOOL SPI0_Master_Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();	
	InitDialogWnd(FALSE);
	
	HICON hlcon = AfxGetApp()->LoadIconW(IDR_SCRIPTHELP);
    m_ScriptHelpBtn.SetIcon(hlcon);

	EnableToolTips(TRUE);

	m_iSpiID = 0;
	CButton* pBtn = (CButton*)GetDlgItem(IDC_RADIO_SPI0);
	pBtn->SetCheck(1);
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void SPI0_Master_Dlg::OnBnClickedBtnSpi0Mode()
{
	// TODO: Add your control notification handler code here	
	InitSpi0MasterSts();
	if(NuUsb.WinUsbNumber > 0)
	{
		GetParent()->SendMessage(WM_LOCK_SCREEN, (WPARAM)1 );
		InitDialogWnd(FALSE);
		GetDlgItem(IDC_RADIO_SPI0)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_SPI2)->EnableWindow(FALSE);
	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		InitDialogWnd(FALSE);
		return;
	}
}

void SPI0_Master_Dlg::OnBnClickedBtnSpi0Disable()
{
	// TODO: Add your control notification handler code here	
	if(NuUsb.WinUsbNumber > 0)
	{
		GetParent()->SendMessage(WM_LOCK_SCREEN, (WPARAM)0);
		InitDialogWnd(TRUE);
		GetDlgItem(IDC_RADIO_SPI0)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_SPI2)->EnableWindow(TRUE);
	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		InitDialogWnd(FALSE);
		return;
	}
}

void SPI0_Master_Dlg::OnBnClickedBtnSpi0Clr()
{
	// TODO: Add your control notification handler code here
	m_EDIT_SPI0.SetWindowText(_T(""));
}

void SPI0_Master_Dlg::OnBnClickedBtnSpi0Load()
{
	// TODO: Add your control notification handler code here
	CFile File;
	UINT dwFileLen=0;
	CString m_strGetPathName;
	//CHAR *SPI_comm;
	TCHAR *SPI_comm;
	UINT uBytesRead = 0;

	if(NuUsb.WinUsbNumber == 0)
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		return;
	}

	CFileDialog dlg(true, NULL, NULL, 0, _T("*.txt|*.TXT|*.*|*.*||"), this);
    if(dlg.DoModal() == IDOK)
	{
		m_strGetPathName = dlg.GetOFN().lpstrFile;     
	}

	if (File.Open(m_strGetPathName,CFile::modeRead))
	{		
		dwFileLen = File.GetLength();

		SPI_comm = new TCHAR[dwFileLen + 1];
		memset(SPI_comm, 0 ,sizeof(TCHAR) * (dwFileLen + 1));
		SPI_comm[dwFileLen]='\0';

		uBytesRead = File.Read(SPI_comm, dwFileLen);
	
		File.Close();
	}
	else
	{
		return;
	}
/*
    for(int n = 0; n < uBytesRead; n++)
	{
		if ( (SPI_comm[n] >= 'g') && (SPI_comm[n] <= 'z') ||
			 (SPI_comm[n] >= 'G') && (SPI_comm[n] <= 'Z') )		
		{
			AfxMessageBox(_T("Input data 0~255 "));
			return;
		}
	}
*/
	CString strSource(SPI_comm);
	m_EDIT_SPI0.SetWindowText(strSource);

	SPI_comm = NULL;
	
}

CString strSPI0Script;
UCHAR ScriptData[1024] = {0};
UCHAR ScriptBitLength[1024] = {0};
UCHAR SPI0CmdBuf[2048] = {0}; 
int CommandLength[256] = {0};
UCHAR RepeatNum[256] = {0};
int line_Head = 0;
int line_Tail = 0;
int cmdCnt = 0;
int scIdx = 0;	
int TotalCmdLength = 0;	

void SPI0_Master_Dlg::OnBnClickedBtnSpi0Go()
{

	// Parsing Input String
	CString strScript;
	CString strLine;
	CString strToken;
	int curPos = 0;
	int curLine = 0;
	
	// Parsing Output Script
	scIdx = 0;
	USHORT cmIdx = 0;

	// Status and Information record
	int status = -1;	// initial status
	UCHAR *pCmdHeader;
	UCHAR Repeat = 1;
	USHORT idleTime = 0;

	UCHAR *pDataHeader;
	UCHAR DataType = 1;		// 1: CHAR, 2: SHORT, 4: INT
	UCHAR BitLength = 8;
	UCHAR DataCount = 0;
	
	
	unsigned int val;
	BOOL bTimeValid = TRUE;

	int ParamSrc = 0;	// 0: Bit Length, 1: Idle time, 2: Repeat
	int ReceiveNum = 0;
	
	
	// Error Message
	CString strErr;
	
	InitSpi0MasterSts();
	// Command Count
	ScriptData[scIdx++] = 0;	// Byte 0: Command Count
	

	m_EDIT_SPI0.GetWindowText(strScript);
	strLine = strScript.Tokenize(_T("\r\n"), curLine);
	
	while(strLine != _T(""))
	{
		curPos = 0; // Reset Line position
		strToken = strLine.Tokenize(_T(" \t"), curPos);
		while(strToken != _T(""))
		{
			if(0 == strToken.Find(_T(";")))
				break; // Change Line

			ReceiveNum++;
			
			strToken.MakeUpper();

			//TRACE(_T("Data Token: %s\n"), strToken);
			//TRACE(_T("ReceiveNum: %d\n"), ReceiveNum);
			
			switch(status)
			{
				case -1: // Not start (Previous command is parsed complete, current command is not parsed.)
					if(strToken == _T("/S"))
					{
COMMAND_START:			
						TotalCmdLength = 0;
						
						pCmdHeader = &ScriptData[scIdx];
						bTimeValid = FALSE;
						
						// Default Value
						idleTime = 0;
						Repeat = 1;
						
						scIdx += 4;
				
						pCmdHeader[0] = 'S';
						pCmdHeader[1] = Repeat;
						pCmdHeader[2] = (idleTime & 0x00FF);
						pCmdHeader[3] = ((idleTime & 0xFF00) >> 8);
						
						
						pDataHeader = &ScriptData[scIdx];
						
						BitLength = 8;
						DataCount = 0;
						DataType = 1;
						
						pDataHeader[0] = BitLength;
						pDataHeader[1] = DataCount;
						
						scIdx += 2;

						status = 0;
					}
					else if(bTimeValid)
					{
						MessageBox(_T("Command should begin with /S"));
						return;
					}
					else // Idle time is found
					{
						TCHAR *pszStopString;
						idleTime = _tcstoul(strToken, &pszStopString, 10);		

						if( _tcsicmp(pszStopString, _T("")) != 0 ) {
							// OK. We reach here.
							strErr.Format(_T("Invalid Idle Duration: %s"), strToken);
							MessageBox(strErr);
							return;
						}
										
						pCmdHeader[2] = (idleTime & 0x00FF);
						pCmdHeader[3] = ((idleTime & 0xFF00) >> 8);
						bTimeValid = TRUE;
					}
					break;
					
				case 0: // Start Found, parsing data   -> found /S success
					if(strToken == _T("/P")) // Stop Token is Found.
					{
					
						if(TotalCmdLength > 1000)
						{
							MessageBox(_T("Script buffer is full"));
							return;
						}
						else
							TotalCmdLength += ReceiveNum;
							
						if(DataCount == 0)
						{
							MessageBox(_T("Data Length == 0"));
							return;
						}
						
						cmIdx++;
						// Insert real count
						pDataHeader[1] = DataCount;
						ScriptData[scIdx++] = 'P';
						status = 1;
					}
					else if(strToken == _T("/B")) // Bit Length Token is Found.
					{
						if(DataCount == 0)
						{
							if(pDataHeader == (pCmdHeader + 4 ))
							{
								ParamSrc = 0;	// Bit Length
								status = 2;							
							}
							else
							{					
								MessageBox(_T("Data Length == 0"));
								return;
							}
						}
						else
						{
							// Insert real count
							pDataHeader[1] = DataCount;
							pDataHeader = &(ScriptData[scIdx]);
							
							DataCount = 0;
							scIdx += 2;
							
							ParamSrc = 0;	// Bit Length
							status = 2;
						}
					}
					else // Data Token is Found.
					{
						TCHAR *pszStopString;
						
						val = _tcstoul(strToken, &pszStopString, 16);		

						if( _tcsicmp(pszStopString, _T("")) != 0 ) {
							// OK. We reach here.
							strErr.Format(_T("%s is not a Hex integer"), strToken);
							MessageBox(strErr);
							return;
						}
						
						for(int i = 0; i < DataType; i++)
						{
							ScriptData[scIdx++] = ((val >> (i * 8)) & 0xFF);
						}
//						ScriptData[scIdx++] = val;	// Valid Data
						DataCount++;
					}
					break;
					
				case 1: // Parsing Key Words, /I and /R
					if(strToken == _T("/I"))
					{
						// Data stage
						ParamSrc = 1;	// Idle Time
						status = 2;
					}
					else if(strToken == _T("/R"))
					{
						// Data stage
						ParamSrc = 2;	// Repeat Count
						status = 2;
					}
					else if(strToken == _T("/S"))
					{
						goto COMMAND_START;						
					}
					else
					{
						// ERROR
					}
					break;
				
				case 2:
					{
						TCHAR *pszStopString;
						
						val = _tcstoul(strToken, &pszStopString, 10);		

						if( _tcsicmp(pszStopString, _T("")) != 0 ) {
							// OK. We reach here.
							strErr.Format(_T("%s is not a valid integer"), strToken);
							MessageBox(strErr);
							return;
						}
						
						if(ParamSrc == 0)
						{
							BitLength = val;
							DataType = (BitLength + 7) / 8;
							pDataHeader[0] = BitLength;
							status = 0;
						}
						else if(ParamSrc == 1)
						{
							idleTime = val;			
							pCmdHeader[2] = (idleTime & 0x00FF);
							pCmdHeader[3] = ((idleTime & 0xFF00) >> 8);
							status = 1;

						}
						else if(ParamSrc == 2)
						{
							Repeat = val;
							pCmdHeader[1] = Repeat;
							status = 1;
							
							TotalCmdLength *= Repeat; 

							if(TotalCmdLength > 1000)
							{
								MessageBox(_T("Script buffer is full"));
								return;
							}
						}
						else
						{
							// Error
						}
						
						
					}					
					break;
					
				default:
					MessageBox(_T("Exception occurred"));
					return;				
			}
			strToken = strLine.Tokenize(_T(" \t"), curPos);
		}
		strLine = strScript.Tokenize(_T("\r\n"), curLine);
	}
	
	//TRACE(_T("TotalCmdLength: %d\n"), TotalCmdLength);

	if(cmIdx == 0)
	{
		MessageBox(_T("No Command"));
		return;
	}

	// Command Count
	ScriptData[0] = cmIdx;
	
	if(0 == m_iSpiID)
		NuUsb.NU_Data2Bridge(ScriptData, scIdx, MODE_SPI0_MASTER);
	else
		NuUsb.NU_Data2Bridge(ScriptData, scIdx, MODE_SPI2_MASTER);

	line_Head = 0;
	line_Tail = 0;
	SPI0DisplayMOSI();
	
}

void SPI0_Master_Dlg::SPI0DisplayMOSI()
{

	UCHAR 	repeat = 0;
	UCHAR 	bitLength = 0;
	UCHAR 	dataCnt = 0;
	USHORT	idleTimeL = 0;
	USHORT	idleTimeH = 0;
	USHORT	DataIndex = 0;
	USHORT	DataByte = 0;
	int IDNum = 0, CmdCntIdx = 0;
	int	Data = 0, printsize = 0;
	
	memset(SPI0CmdBuf, 0, sizeof(UCHAR)*2048);
	cmdCnt = ScriptData[line_Head++];
	scIdx--;

	while(cmdCnt)  // cmd cnt
	{
		if('S' == ScriptData[line_Head++])
		{
			repeat = ScriptData[line_Head++];
			RepeatNum[IDNum] = repeat;
			idleTimeL = ScriptData[line_Head++];
			idleTimeH = ScriptData[line_Head++];
			idleTimeL += (idleTimeH << 8);

			scIdx -= 4;
		}
		else
		{
			// Error
			scIdx = 0;
			return;
		}

		DataIndex = line_Head;
		DataByte = 	scIdx;
		
		while(repeat)
		{
			line_Head = DataIndex;
			scIdx = DataByte;
			
		
SPI_CHANGE_BIT_LENGTH:

			bitLength = ScriptData[line_Head];
			line_Head++;
			dataCnt = ScriptData[line_Head++];
			
				
			switch((bitLength + 7) >> 3)
			{
				case 1:
					while(dataCnt)
					{
						ScriptBitLength[line_Tail] = bitLength;

						Data = ScriptData[line_Head++];
						scIdx--;
					
						SPI0CmdBuf[line_Tail++] = Data & 0xFF;										
						line_Tail &= 0x7FF;  // 2047
											

						printsize++;
						dataCnt--;					
					}
					break;
				case 2:
					while(dataCnt)
					{
						Data = ScriptData[line_Head++];
						Data += (ScriptData[line_Head++] << 8);
						scIdx -= 2;
						
						ScriptBitLength[line_Tail] = bitLength;
						SPI0CmdBuf[line_Tail++] = (Data >> 8) & 0xFF;
						line_Tail &= 0x7FF;  // 2047

						ScriptBitLength[line_Tail] = bitLength;
						SPI0CmdBuf[line_Tail++] = Data & 0xFF;
						line_Tail &= 0x7FF;  // 2047

						printsize += 2;
						dataCnt--;
					}
					break;
				case 3:
					while(dataCnt)
					{
						Data = ScriptData[line_Head++];
						Data += (ScriptData[line_Head++] << 8);
						Data += (ScriptData[line_Head++] << 16);
						scIdx -= 3;
										
						ScriptBitLength[line_Tail] = bitLength;
						SPI0CmdBuf[line_Tail++] = (Data >> 16) & 0xFF;
						line_Tail &= 0x7FF;  // 2047

						ScriptBitLength[line_Tail] = bitLength;
						SPI0CmdBuf[line_Tail++] = (Data >> 8) & 0xFF;
						line_Tail &= 0x7FF;  // 2047
						
						ScriptBitLength[line_Tail] = bitLength;
						SPI0CmdBuf[line_Tail++] = Data & 0xFF;
						line_Tail &= 0x7FF;  // 2047						
						
						printsize += 3;
						dataCnt--;
					}
					break;
				case 4:
					while(dataCnt)
					{						
						Data = ScriptData[line_Head++];
						Data += (ScriptData[line_Head++] << 8);
						Data += (ScriptData[line_Head++] << 16);
						Data += (ScriptData[line_Head++] << 24);
						scIdx -= 4;
						
						ScriptBitLength[line_Tail] = bitLength;
						SPI0CmdBuf[line_Tail++] = (Data >> 24) & 0xFF;
						line_Tail &= 0x7FF;  // 2047

						ScriptBitLength[line_Tail] = bitLength;
						SPI0CmdBuf[line_Tail++] = (Data >> 16) & 0xFF;
						line_Tail &= 0x7FF;  // 2047
						
						ScriptBitLength[line_Tail] = bitLength;
						SPI0CmdBuf[line_Tail++] = (Data >> 8) & 0xFF;
						line_Tail &= 0x7FF;  // 2047

						ScriptBitLength[line_Tail] = bitLength;
						SPI0CmdBuf[line_Tail++] = Data & 0xFF;
						line_Tail &= 0x7FF;  // 2047

						printsize += 4;
						dataCnt--;
					}
					break;
				default:
					break;
			}
			
			
			if('P' == ScriptData[line_Head])	
			{
				line_Head++;
			}
			else
				goto SPI_CHANGE_BIT_LENGTH;
			
			
			repeat--;
		}
		
		
		repeat = RepeatNum[IDNum];
		printsize /= repeat;
		while(repeat)
		{
			CommandLength[CmdCntIdx++] = printsize;
			repeat--;
		}
		printsize = 0;

		IDNum++;
		cmdCnt--;
	}

	cmdCnt = IDNum;
}


void SPI0_Master_Dlg::OnBnClickedBtnSpi0ParmInit()
{
	// TODO: Add your control notification handler code here
	SPI_Para_Dlg SPI0ParaDlg;
	
	if(m_iSpiID == 0)
		SPI0ParaDlg.m_iSpiMode = MODE_SPI0_MASTER;
	else
		SPI0ParaDlg.m_iSpiMode = MODE_SPI2_MASTER;

	if(NuUsb.WinUsbNumber > 0)
	{
		SPI0ParaDlg.DoModal();
	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
	}
}

void SPI0_Master_Dlg::InitDialogWnd(bool bShow)
{
	int i;

	if(!m_bInit)
	{
		int i = 0;
		
		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_MODE, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();


		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_GO, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_LOAD, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();


		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_CLR, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();


		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_CONFIG, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();


		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_STOP, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_SAVE, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_bInit = TRUE;
		m_CtrlCnt = i;

	}

	if(NuUsb.WinUsbNumber == 0)
	{
		// Disable All Member		
		m_EDIT_SPI0.EnableWindow(FALSE);
		//m_ScriptHelpBtn.EnableWindow(FALSE);
		for(i = 0; i < m_CtrlCnt; i++)
		{
			m_SPI0btns[i].EnableWindow(FALSE);
		}
	}
	else
	{
		m_SPI0btns[0].EnableWindow(bShow);	
		m_EDIT_SPI0.EnableWindow(!bShow);
		//m_ScriptHelpBtn.EnableWindow(!bShow);
		for(i = 1; i < m_CtrlCnt; i++)
		{
			m_SPI0btns[i].EnableWindow(!bShow);
		}
	}
	//m_SPI0btns[6].ShowWindow(FALSE);
}

void SPI0_Master_Dlg::SPI0SwitchLang(HINSTANCE tmpDll, int LanguageIdx)
{
	CString text;
    int i;

	if(tmpDll && (m_iLanguage > 0))
	{
		text.LoadString(tmpDll, IDS_SPISCRIPT);
		GetDlgItem(IDC_STATIC_SPI0_SCRIPT)->SetWindowText(text);
	}

	if(LanguageIdx == 1)
	{
		i = 0;
		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_MODE, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_GO, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_LOAD, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_CLR, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_CONFIG, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_STOP, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();	

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHT_BTN_SAVE, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();
	}
	else if(LanguageIdx == 2)
	{
		i = 0;
		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_MODE, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_GO, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_LOAD, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_CLR, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_CONFIG, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_STOP, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_CHS_BTN_SAVE, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();
	}
	else    // default language(English)
	{
		i = 0;
		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_MODE, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_GO, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_LOAD, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_CLR, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_CONFIG, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_STOP, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		m_SPI0btns[i].SetBitmaps(IDB_BITMAP_BTN_SAVE, RGB(0, 255, 0)); 
		m_SPI0btns[i++].DrawTransparent();

		GetDlgItem(IDC_STATIC_SPI0_SCRIPT)->SetWindowText(_T("SPI Script"));
	}

	LangDll = tmpDll;
}
void SPI0_Master_Dlg::OnOK()
{
	// TODO: Add your specialized code here and/or call the base class

	//CDialog::OnOK();
}

void SPI0_Master_Dlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class

	//CDialog::OnCancel();
}

void SPI0_Master_Dlg::OnBnClickedSpi0ScriptHelpBtn()
{
	// TODO: Add your control notification handler code here
	SPI0_Script_Help_Dlg SPI0ScriptHelpDlg;
	CString strSource1, strSource;
	/*
	if(NuUsb.WinUsbNumber > 0)
	{
		SPI0ScriptHelpDlg.DoModal();
		strSource1 =  _T("/S 11 12 13 /B 10 123 223 323 /B 16 4455 6677 /P /I 1000 /R 3");	

		strSource.Format(_T("%s"), strSource1);
		m_EDIT_SPI0.SetWindowText(strSource);

	}
	else
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
	}
	*/
	SPI0ScriptHelpDlg.DoModal();
	strSource1 =  _T("/S 11 12 13 /B 10 123 223 323 /B 16 4455 6677 /P /I 1000 /R 3");	

	strSource.Format(_T("%s"), strSource1);
	m_EDIT_SPI0.SetWindowText(strSource);
}

void SPI0_Master_Dlg::OnBnClickedBtnSpi0Save()
{
	// TODO: Add your control notification handler code here
	CFile File;
	CString m_strGetPathName;
	CString strScript;

	UINT dwFileLen=0;
	UINT uBytesRead = 0;
	TCHAR *OutScript; 

	if(NuUsb.WinUsbNumber == 0)
	{
		AfxMessageBox(_T("Nu-Bridge Not Found"));
		return;
	}

	CFileDialog dlg(FALSE, _T("txt"), _T("*.txt"), OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,  _T("*.txt|*.TXT|*.*|*.*||"));   

	if(dlg.DoModal() == IDOK)
	{
		m_strGetPathName = dlg.GetOFN().lpstrFile;     
	}

	m_EDIT_SPI0.GetWindowText(strScript);
	
	

	if (File.Open(m_strGetPathName, CFile::modeCreate | CFile::modeWrite))
	{				      
		dwFileLen = strScript.GetLength();

		OutScript = new TCHAR[dwFileLen + 1];
		memset(OutScript, 0 ,sizeof(TCHAR) * (dwFileLen + 1));

		OutScript = strScript.GetBuffer(strScript.GetLength());
		strScript.ReleaseBuffer();

		//File.Write(strScript, sizeof(char)*strScript.GetLength() * 2);
		File.Write(OutScript, sizeof(TCHAR)*strScript.GetLength() * 2);
		File.Flush();

		File.Close();
	}
	else
	{
		return;
	}

	OutScript = NULL;
}

BOOL SPI0_Master_Dlg::SetTipText(UINT id, NMHDR *pTTTStruct, LRESULT *pResult)
{
	TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pTTTStruct;          
	UINT nID = pTTTStruct->idFrom; 

	if (pTTT->uFlags & TTF_IDISHWND)  
	{
		nID = ::GetDlgCtrlID((HWND)nID);
		if (NULL == nID)
			return FALSE;
		
		switch(nID)
		{
			case IDC_SPI0_SCRIPT_HELP_BTN:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Show Script Command example.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_HELP);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}	
			break;  
				
			case IDC_BTN_SPI0_PARM_INIT:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Config SPI Master parameter.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_CONFIG);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}
			break;
			
			case IDC_BTN_SPI0_MODE:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Start SPI Master.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_MODE);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}	
			break;
			
			case IDC_BTN_SPI0_DISABLE:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Stop SPI Master.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_DISABLE);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}				
			break;
			
			case IDC_BTN_SPI0_LOAD:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Load SPI script from PC.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_LOAD);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}				
			break;
			
			case IDC_BTN_SPI0_SAVE:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Save SPI script to PC.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_SAVE);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}				
			break;
			
			case IDC_BTN_SPI0_GO:
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Send SPI master data to NuBridge.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_GO);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}				
			break;
			
			case IDC_BTN_SPI0_CLR:				
			{
				if(LangDll == NULL)
					pTTT->lpszText = _T("Clear script.");
				else
				{
					ToolTipStr.LoadString(LangDll, IDS_TOOLTIP_SPI0_CLEAR);
					pTTT->lpszText = (LPWSTR)((LPCTSTR)ToolTipStr);
				}
			}
			break;			
			

			default:
				break;
		}

		return TRUE;
	}  
	return FALSE;    
}

void SPI0_Master_Dlg::OnBnClickedRadioSpi0()
{
	// TODO: Add your control notification handler code here
	m_iSpiID = 0;
	CNuTabCtrl* pCtrl = (CNuTabCtrl*)GetParent();
	pCtrl->GetCurrentModule();
}

void SPI0_Master_Dlg::OnBnClickedRadioSpi2()
{
	// TODO: Add your control notification handler code here
	m_iSpiID = 2;
	CNuTabCtrl* pCtrl = (CNuTabCtrl*)GetParent();
	pCtrl->GetCurrentModule();
}
