/*---------------------------------------------------------------------------------------------------------*/
/*																										   */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.										   */
/*																										   */
/*---------------------------------------------------------------------------------------------------------*/

#pragma once
#include "afxwin.h"
#include <NuWinUsb.h>
#include <NumEdit.h>
#include "SPI_Para_Dlg.h"

#include "BtnST.h"
#include "ShadeButtonST.h"

// SPI0_Master_Dlg dialog

class SPI0_Master_Dlg : public CDialog
{
	DECLARE_DYNAMIC(SPI0_Master_Dlg)

public:
	SPI0_Master_Dlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~SPI0_Master_Dlg();

// Dialog Data
	enum { IDD = IDD_SPI0_MASTER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();

	CNumEdit m_EDIT_SPI0;
	CShadeButtonST	m_SPI0btns[7];


	BOOL m_bInit;
	int  m_CtrlCnt;
	int  m_iSpiID;


	void InitDialogWnd(bool);
	void SPI0SwitchLang(HINSTANCE tmpDll, int LanguageIdx);	
	void SPI0DisplayMOSI(void);
	afx_msg void OnBnClickedBtnSpi0Mode();
	afx_msg void OnBnClickedBtnSpi0Disable();
	afx_msg void OnBnClickedBtnSpi0Clr();
	afx_msg void OnBnClickedBtnSpi0Load();
	afx_msg void OnBnClickedBtnSpi0Go();
	afx_msg void OnBnClickedBtnSpi0ParmInit();
	BOOL SetTipText(UINT id, NMHDR *pTTTStruct, LRESULT *pResult);
protected:
	virtual void OnOK();
	virtual void OnCancel();
	HINSTANCE LangDll;
public:
	afx_msg void OnBnClickedSpi0ScriptHelpBtn();
	CButton m_ScriptHelpBtn;
	afx_msg void OnBnClickedBtnSpi0Save();
	CString ToolTipStr;
	afx_msg void OnBnClickedRadioSpi0();
	afx_msg void OnBnClickedRadioSpi2();
};
