/*---------------------------------------------------------------------------------------------------------*/
/*																										   */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.										   */
/*																										   */
/*---------------------------------------------------------------------------------------------------------*/
#ifndef NUCWINUSP_H
#define NUCWINUSP_H

// Include WinUSB headers
#include "stdafx.h"

#include "winusb.h"
#include <Usb100.h>


#include <Setupapi.h>

#include <algorithm>
#include <vector>

#include "NuBridgeAPI.h"
#include <strsafe.h>
typedef struct PIPE_ID
{
	UCHAR  PipeInId;
	UCHAR  PipeOutId;
}Pipe_Id,*PPipe_Id;

typedef struct WINUSBHANDLE
{
	HANDLE hDeviceHandle;
	WINUSB_INTERFACE_HANDLE hUSBHandle;
	Pipe_Id pipeid;	
	CString DevicePath;
}SWinUsbHandle,*PSWinUsbHandle;

#define MAX_DEVICE_NUM 32
class CNuWinUsb
{
	public:
		CNuWinUsb();
		~CNuWinUsb();
		SWinUsbHandle WinUsbHandle[MAX_DEVICE_NUM];
		int WinUsbNumber;
		int m_ActiveDevice;
		int m_WorkDevice;

		UCHAR DeviceSpeed;
		
		BOOL EnableWinUsbDevice(void);		
		BOOL NU_WritePipe(UCHAR *buf,ULONG len);
		//BOOL NU_WriteAck(int id,ULONG len);
		BOOL NU_SetType(int id,USHORT type,UCHAR * ack,ULONG len);
		ULONG NU_ReadPipe(int id, UCHAR *buf,ULONG len);
		void NU_CloseHandle(void);
		int NU_CheckDevice(CString szDevId);



		// JCT 0928
		BOOL NU_AbortReadPipe(int id);
		// JCT 0930
		BOOL NU_SetBridgeStop(UCHAR Mode);
		BOOL NU_SetBridgeMode(UCHAR Mode);
		BOOL NU_SetDeviceLED(int id);
		BOOL NU_GetBridgeParam(UCHAR *PARM);
		BOOL CNuWinUsb::NU_Test(void);

		BOOL NU_SetSPIParam(int iMode, UCHAR setting);
		BOOL NU_SetI2C0Param(UCHAR setting);
			
		UCHAR NU_GetSPIParam(int iMode);
		UCHAR NU_GetI2C0Param(void);

		BOOL CNuWinUsb::NU_ResetFW(void);

		BOOL NU_Data2Bridge(UCHAR *Buf, int Size, UCHAR Type);
		
		
		HANDLE m_hReadEvent;
		HANDLE m_hWriteEvent;
	protected:
		
		BOOL GetDeviceHandle(void);
		BOOL GetWinUSBHandle(void);
		BOOL GetUSBDeviceSpeed(void);
		BOOL QueryDeviceEndpoints(void);		
};

extern CNuWinUsb NuUsb; //shanchun

#endif